/*
 ============================================================================
 Kaloth's Transparent Window Plugin! - BBwintrans
 ============================================================================
 
 This plugin lets you assign transparent attributes to any application window.
 
 ============================================================================
*/

#ifndef _WIN32_WINNT
#define _WIN32_WINNT 0x0500
#endif

#ifdef __GNUC__
#define _WIN32_IE 0x0500
#define GetBlackboxPath _GetBlackboxPath
#define DLL_EXPORT //__declspec(dllexport)
#define LWA_ALPHA 2
#endif

#ifdef __BORLANDC__
#define DLL_EXPORT
#endif

#include "../../includes/BBApi.h"
#include <stdlib.h>
#include <string.h>
#include <winuser.h>
#include <windows.h>
#include <psapi.h>

#pragma comment (lib, "psapi.lib")
#pragma comment (lib, "user32.lib")

#define STREQ(str1, str2) (strcmp((str1), (str2)) == 0)

void ReadRCSettings();

extern "C"
{
	DLL_EXPORT int beginPlugin(HINSTANCE hMainInstance);
	DLL_EXPORT void endPlugin(HINSTANCE hMainInstance);
	DLL_EXPORT LPCSTR pluginInfo(int field);
}

LPSTR szAppName         = "BBwintrans";          // The name of our window class, etc.
LPSTR szVersion         = "BBwintrans v0.7b";   // Used in MessageBox titlebars
LPSTR szInfoVersion     = "v0.7b";
LPSTR szInfoAuthor      = "Kaloth";
LPSTR szInfoRelDate     = "2006-07-29";
LPSTR szInfoLink        = "http://www.geocities.com/madant8";
LPSTR szInfoEmail       = "mulletwarriorextreem@hotmail.com";
LPSTR updateURL		= "www.geocities.com/madant8/meta.html";
#define PLUGIN_UPDATE_URL 8

//===========================================================================
HINSTANCE hInstance;
HWND hwndBlackbox, hwndPlugin;
OSVERSIONINFO  osvinfo;

char rcpath[MAX_PATH];

bool usingWin2kXP;
bool hooked;

int levels[50]; // 50 stored transparency levels.
char apps[50][10]; // 50 stored app names.
char rules[50][10]; // 50 stored transparency rules.
char exclude[50][10]; // 50 stored app names to exclude.
char global[10]; // The global rule.
int globlevel; // The global transparency value.
int focuslevel; // The transparency level for windows in focus when using the focus rule.

HWINEVENTHOOK eventhook_CREATE;
HWINEVENTHOOK eventhook_FOREGROUND;
HWINEVENTHOOK eventhook_MOVE;

//===========================================================================

char *toUpper(char *str){
	char *ptr;
	ptr = str;
	while(*ptr != '\0'){
		*ptr = toupper(*ptr);
		ptr++;
	}
	return str;
}

int isIncluded(char *module){
	int n;
	if(strcmp(module, "") == 0)
		return -1;
	for(n = 0; n < 50; n++){
		if(strcmp(apps[n], "") != 0){
			if(strstr(module, apps[n])){
				return n;
			}
		}
	}
	return -1;
}

void makeWindowTransparent(HWND hwnd, char transparency, char *module){
	if(IsWindow(hwnd)){
		if(strcmp(module, "") == 0)
			return;
		for(int n = 0; n < 50; n++){
			if(strcmp(exclude[n], "") != 0){
				if(strstr(module, exclude[n])){
					return;
				}
			}
		}
		if(transparency != 255){
			// Add the WS_EX_LAYERED atribute to the window.
			SetWindowLong(hwnd, GWL_EXSTYLE , GetWindowLong(hwnd, GWL_EXSTYLE) | WS_EX_LAYERED);
			// Look at what settings it already had...
			COLORREF colour = NULL;
			GetLayeredWindowAttributes(hwnd, &colour, NULL, NULL);
			// Make it transparent.
			SetLayeredWindowAttributes(hwnd, colour, transparency, (colour == NULL)?LWA_ALPHA:LWA_ALPHA|LWA_COLORKEY);
		}else{
			// Look at what settings it already had...
			COLORREF colour = NULL;
			GetLayeredWindowAttributes(hwnd, &colour, NULL, NULL);
			if(colour == NULL){
				// Remove the WS_EX_LAYERED atribute to the window.
				SetWindowLong(hwnd, GWL_EXSTYLE, GetWindowLong(hwnd, GWL_EXSTYLE) & ~WS_EX_LAYERED);
			}else{
				// Make it opaque.
				SetLayeredWindowAttributes(hwnd, colour, 255, (colour == NULL)?LWA_ALPHA:LWA_ALPHA|LWA_COLORKEY);
			}
		}
	}
}

// Callback function that will recieve all the windows.
BOOL CALLBACK EnumWindowsOpaque(HWND hwnd, LPARAM lParam){
	if(IsWindow(hwnd)){
		TCHAR buffer[50];
		DWORD pid, count;
		HMODULE hm[1];
		HANDLE hProcess;
		
		GetWindowThreadProcessId(hwnd, &pid);
		hProcess = OpenProcess(PROCESS_QUERY_INFORMATION | PROCESS_VM_READ, 0, pid);
		EnumProcessModules(hProcess, hm, sizeof(hm), &count);
		GetModuleFileNameEx(hProcess, hm[0], buffer, sizeof(buffer));
		CloseHandle(hProcess);
		toUpper(buffer);
		
		makeWindowTransparent(hwnd, 255, buffer); // make all windows opaque.
	}
	return 1;
}

// Callback function that will recieve all the windows.
BOOL CALLBACK EnumWindowsAlwaysInit(HWND hwnd, LPARAM lParam){
	if(IsWindow(hwnd) && IsWindowVisible(hwnd)){
		TCHAR buffer[50];
		DWORD pid, count;
		HMODULE hm[1];
		HANDLE hProcess;
		
		GetWindowThreadProcessId(hwnd, &pid);
		hProcess = OpenProcess(PROCESS_QUERY_INFORMATION | PROCESS_VM_READ, 0, pid);
		EnumProcessModules(hProcess, hm, sizeof(hm), &count);
		GetModuleFileNameEx(hProcess, hm[0], buffer, sizeof(buffer));
		toUpper(buffer);
		int n = isIncluded(buffer);
		CloseHandle(hProcess);
		
		if(n >= 0){
			if (strcmp(rules[n], "ALWAYS") == 0)
				makeWindowTransparent(hwnd, levels[n], buffer);
		}else{
			if(strcmp(global, "ALWAYS") == 0)
				makeWindowTransparent(hwnd, globlevel, buffer);
		}
	}
	return 1;
}

// Callback function that will recieve all the windows.
BOOL CALLBACK EnumWindowsProc(HWND hwnd, LPARAM lParam){
	if(IsWindow(hwnd) && IsWindowVisible(hwnd)){
		TCHAR buffer[50];
		DWORD pid, count;
		HMODULE hm[1];
		HANDLE hProcess;
		HWND foreground = (HWND) lParam;
		
		GetWindowThreadProcessId(hwnd, &pid);
		hProcess = OpenProcess(PROCESS_QUERY_INFORMATION | PROCESS_VM_READ, 0, pid);
		EnumProcessModules(hProcess, hm, sizeof(hm), &count);
		GetModuleFileNameEx(hProcess, hm[0], buffer, sizeof(buffer));
		toUpper(buffer);
		int n = isIncluded(buffer);
		CloseHandle(hProcess);
		
		if(n >= 0){
			if (strcmp(rules[n], "FOCUS") == 0)
				(hwnd == foreground) ? makeWindowTransparent(hwnd, focuslevel, buffer) : makeWindowTransparent(hwnd, levels[n], buffer);
		}else{
			if(strcmp(global, "FOCUS") == 0)
				(hwnd == foreground) ? makeWindowTransparent(hwnd, focuslevel, buffer) : makeWindowTransparent(hwnd, globlevel, buffer);
		}
	}
	return 1;
}

VOID CALLBACK WinEventProc(	HWINEVENTHOOK hWinEventHook, DWORD event, HWND hwnd, 
				LONG idObject, LONG idChild, DWORD dwEventThread, DWORD dwmsEventTime){			
	int n;
	TCHAR buffer[50];
	DWORD pid, count;
	HMODULE hm[1];
	HANDLE hProcess;
	
	GetWindowThreadProcessId(hwnd, &pid);
	hProcess = OpenProcess(PROCESS_QUERY_INFORMATION | PROCESS_VM_READ, 0, pid);
	EnumProcessModules(hProcess, hm, sizeof(hm), &count);
	GetModuleFileNameEx(hProcess, hm[0], buffer, sizeof(buffer));
	CloseHandle(hProcess);
	toUpper(buffer);
	
	n = isIncluded(buffer);
	switch(event){
		case EVENT_OBJECT_CREATE:
			if(n >= 0){
				if (strcmp(rules[n], "ALWAYS") == 0)
					makeWindowTransparent(hwnd, levels[n], buffer);
			}else{
				if(strcmp(global, "ALWAYS") == 0)
					makeWindowTransparent(hwnd, globlevel, buffer);
			}
			break;
		case EVENT_SYSTEM_MOVESIZESTART:
			if(n >= 0){
				if (strcmp(rules[n], "MOVING") == 0)
					makeWindowTransparent(hwnd, levels[n], buffer);
			}else{
				if(strcmp(global, "MOVING") == 0)
					makeWindowTransparent(hwnd, globlevel, buffer);
			}
			break;
		case EVENT_SYSTEM_MOVESIZEEND:
			if(n >= 0){
				if (strcmp(rules[n], "MOVING") == 0)
					makeWindowTransparent(hwnd, 255, buffer);
			}else{
				if(strcmp(global, "MOVING") == 0)
					makeWindowTransparent(hwnd, 255, buffer);
			}
			break;
		case EVENT_SYSTEM_FOREGROUND:
			EnumWindows((WNDENUMPROC)EnumWindowsProc, (LPARAM)hwnd);
			break;
	}
}

void hook(){
	eventhook_CREATE = SetWinEventHook(
		EVENT_OBJECT_CREATE,
		EVENT_OBJECT_CREATE,
		GetModuleHandle(NULL),
		(WINEVENTPROC) WinEventProc,
		0, // get stuff from all processes.
		0, // all threads.
		WINEVENT_OUTOFCONTEXT | WINEVENT_SKIPOWNTHREAD); // Don't look at ourself because we'll get an infinite loop ;p
		
	eventhook_FOREGROUND = SetWinEventHook(
		EVENT_SYSTEM_FOREGROUND,
		EVENT_SYSTEM_FOREGROUND,
		GetModuleHandle(NULL),
		(WINEVENTPROC) WinEventProc,
		0, // get stuff from all processes.
		0, // all threads.
		WINEVENT_OUTOFCONTEXT | WINEVENT_SKIPOWNTHREAD); // Don't look at ourself because we'll get an infinite loop ;p
		
	eventhook_MOVE = SetWinEventHook(
		EVENT_SYSTEM_MOVESIZESTART,
		EVENT_SYSTEM_MOVESIZEEND,
		GetModuleHandle(NULL),
		(WINEVENTPROC) WinEventProc,
		0, // get stuff from all processes.
		0, // all threads.
		WINEVENT_OUTOFCONTEXT | WINEVENT_SKIPOWNTHREAD); // Don't look at ourself because we'll get an infinite loop ;p
	
	// Initialise all the always transparent windows.
	EnumWindows((WNDENUMPROC)EnumWindowsAlwaysInit, NULL);
	
	hooked = true;
}

void unhook(){
	UnhookWinEvent(eventhook_CREATE);
	UnhookWinEvent(eventhook_FOREGROUND);
	UnhookWinEvent(eventhook_MOVE);
	
	// make all windows opaque.
	EnumWindows((WNDENUMPROC)EnumWindowsOpaque, NULL);
	
	hooked = false;
}

//===========================================================================

int beginPlugin(HINSTANCE hPluginInstance){
	LRESULT CALLBACK WndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam);
	WNDCLASS wc;
	
	ZeroMemory(&osvinfo, sizeof(osvinfo));
	osvinfo.dwOSVersionInfoSize = sizeof (osvinfo);
	GetVersionEx(&osvinfo);
	usingWin2kXP =
		osvinfo.dwPlatformId == VER_PLATFORM_WIN32_NT
		&& osvinfo.dwMajorVersion > 4;

	hwndBlackbox = GetBBWnd();
	hInstance = hPluginInstance;

	// Register the window class...
	ZeroMemory(&wc,sizeof(wc));
	wc.lpfnWndProc = WndProc;           // our window procedure
	wc.hInstance = hPluginInstance;     // hInstance of .dll
	wc.lpszClassName = szAppName;       // our window class name
	wc.hCursor = LoadCursor(NULL, IDC_ARROW);
	wc.style = CS_DBLCLKS;

	if (!RegisterClass(&wc)) 
	{
		MessageBox(hwndBlackbox,
			"Error registering window class", szVersion,
				MB_OK | MB_ICONERROR | MB_TOPMOST);
		return 1;
	}
	
	// Get plugin and style settings...
	ReadRCSettings();

	// Create the window...
	if (!CreateWindowEx(
		usingWin2kXP ? WS_EX_TOOLWINDOW | WS_EX_LAYERED : WS_EX_TOOLWINDOW, // window style
		szAppName,                      // our window class name
		NULL,                           // NULL -> does not show up in task manager!                
		WS_POPUP
		| WS_CLIPCHILDREN
		| WS_CLIPSIBLINGS,             // window parameters
		0,                           // x position
		0,                           // y position
		0,                          // window width
		0,                         // window height
		NULL,                           // parent window
		NULL,                           // no menu
		hPluginInstance,                // hInstance of .dll
		NULL))
	{                          
		MessageBox(0,
			"Error creating window", szVersion,
				MB_OK | MB_ICONERROR | MB_TOPMOST);
		return 1;
	}
	
	hooked = false;
	// Hook the window creation messages(only if win2000/XP!).
	if(usingWin2kXP){
		hook();
	}else{
		// Tell the user about the problem...
		MessageBox(NULL, "BBwintrans needs Win2000/XP!\n\nSorry :(", "BBwintrans - ERROR!", MB_OK | MB_ICONERROR);
		return 1;
	}
	
	
	
	return 0;
}

//===========================================================================

void endPlugin(HINSTANCE hPluginInstance){
	// Destroy the window...
	DestroyWindow(hwndPlugin);

	// Unregister window class...
	UnregisterClass(szAppName, hPluginInstance);
	
	// Unhook (only if win2000/XP!).
	if(usingWin2kXP){
		unhook();
	}
}

//===========================================================================

LPCSTR pluginInfo(int field){
	// pluginInfo is used by Blackbox for Windows to fetch information about
	// a particular plugin. At the moment this information is simply displayed
	// in an "About loaded plugins" MessageBox, but later on this will be
	// expanded into a more advanced plugin handling system. Stay tuned! :)
	switch (field)
	{
		case PLUGIN_NAME:
			return szAppName;       // Plugin name
		case PLUGIN_VERSION:
			return szInfoVersion;   // Plugin version
		case PLUGIN_AUTHOR:
			return szInfoAuthor;    // Author
		case PLUGIN_RELEASE:
			return szInfoRelDate;   // Release date, preferably in yyyy-mm-dd format
		case PLUGIN_LINK:
			return szInfoLink;      // Link to author's website
		case PLUGIN_EMAIL:
			return szInfoEmail;     // Author's email
		case PLUGIN_UPDATE_URL:
			return updateURL;	// Dev's online update meta file
		default:
			return szVersion;       // Fallback: Plugin name + version, e.g. "MyPlugin 1.0"
	}
}

//===========================================================================

void ReadRCSettings(){
	char defaultpath[MAX_PATH]; int nLen, i;
	// First we look for the config file in the same folder as the plugin...
	GetModuleFileName(hInstance, rcpath, sizeof(rcpath));
	for (i=0;;i++)
	{
		nLen = strlen(rcpath); while (nLen && rcpath[nLen-1] != '\\') nLen--;
		// ...check the two possible filenames 'examplerc' and 'example.rc'...
		strcpy(rcpath+nLen, "BBwintransrc");  if (FileExists(rcpath)) break;
		strcpy(rcpath+nLen, "BBwintrans.rc"); if (FileExists(rcpath)) break;
		if (0 == i)
		{   //...if not found aside the plugin, we keep this as the default path...
			strcpy(defaultpath, rcpath);
			//...and try the Blackbox directory.
			GetBlackboxPath(rcpath, sizeof(rcpath));
			continue;
		}
		//if again no config file was found, we use the default path...
		strcpy(rcpath, defaultpath);
		break; // ...and quit the loop
	}
	// If a config file was found we read the plugin settings from it...
	// ...if not, the ReadXXX functions give us just the defaults.
	
	strcpy(global, ReadString(rcpath, "BBwintrans.plugin.global:", ""));
	toUpper(global);
	globlevel = ReadInt(rcpath, "BBwintrans.plugin.globallevel:", 255);
	focuslevel = ReadInt(rcpath, "BBwintrans.plugin.focuslevel:", 255);
	
	char buffer[50];
	int n = 0;
	for(n = 0; n < 50; n++){
		sprintf(buffer, "BBwintrans.plugin.level%d:", n);
		levels[n] = ReadInt(rcpath, buffer, 255);
		
		sprintf(buffer, "BBwintrans.plugin.appname%d:", n);
		strcpy(apps[n], ReadString(rcpath, buffer, ""));
		toUpper(apps[n]);
		
		sprintf(buffer, "BBwintrans.plugin.rule%d:", n);
		strcpy(rules[n], ReadString(rcpath, buffer, ""));
		toUpper(rules[n]);
		
		sprintf(buffer, "BBwintrans.plugin.exclude%d:", n);
		strcpy(exclude[n], ReadString(rcpath, buffer, ""));
		toUpper(exclude[n]);
	}
}

LRESULT CALLBACK WndProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	char szTemp[MAX_PATH];
	
	// Blackbox messages we want to "subscribe" to:
	// BB_RECONFIGURE -> Sent when changing style and on reconfigure
	// BB_BROADCAST -> Broadcast message (bro@m)
	static int msgs[] = { BB_RECONFIGURE, BB_BROADCAST, 0};

	switch (message)
	{       
		// ==========
		case WM_CREATE:
			// set the global variable
			hwndPlugin = hwnd;

			// Register to receive Blackbox messages...
			SendMessage(hwndBlackbox, BB_REGISTERMESSAGE, (WPARAM)hwnd, (LPARAM)msgs);
			break;

		// ==========
		case WM_DESTROY:
			// Unregister Blackbox messages...
			SendMessage(hwndBlackbox, BB_UNREGISTERMESSAGE, (WPARAM)hwnd, (LPARAM)msgs);
			break;

		// ==========
		// If Blackbox sends a reconfigure message, load the new style settings and
		// update the window...

		case BB_RECONFIGURE:
			ReadRCSettings();
			break;

		// ==========
		// Broadcast messages (bro@m -> the bang killah! :D <vbg>)
		case BB_BROADCAST:
		{
			const char *msg_string = (LPCSTR)lParam;

			// ==========
			// ...then we check for the plugin bro@ms that are available to
			// the end-user (ie. listed in the documentation! <g>)...
			if (!strcmp(msg_string, "@BBWintransTog"))
			{
				if(usingWin2kXP){
					if(hooked){unhook();}else{hook();}
				}
				break;
			}
			break;
		}
		
		// ==========
		// Prevent closing with alt-f4
		case WM_CLOSE:
			break;

		// ==========
		// Let windows do everything else
		default:
			return DefWindowProc(hwnd,message,wParam,lParam);
	}
	// return zero, except from the hit-test message
	return 0;
}
